package jtail;

import java.io.*;

import org.xml.sax.*;
import org.apache.commons.digester.*;

/**
 *	XML`̐ݒt@CǂݍރNX
 */
public class ConfigReader
{
	public static JTailData readConfig(File file) throws IOException, SAXException
	{
		Digester d = new Digester();
		d.setValidating(false);

		// /jtail
		d.addObjectCreate("jtail", JTailData.class);
		d.addSetProperties("jtail");

		// /jtail/cut-filter
		d.addObjectCreate("jtail/cut-filter", CutFilter.class);
		d.addSetProperties("jtail/cut-filter");
		d.addSetNext("jtail/cut-filter", "addFilter");

		// /jtail/color-filter
		d.addObjectCreate("jtail/color-filter", ColorFilter.class);
		d.addSetProperties("jtail/color-filter");
		d.addSetNext("jtail/color-filter", "addFilter");

		JTailData data = (JTailData)d.parse(file);
		return data;
	}
}
