package jtail;

import java.io.*;
import java.util.*;

/**
 *	ʂɕ\f[^ێNX
 */
public class JTailData
{
	// eLXgf[^
	private StringBuffer data;

	// sR[h
	private static final String lineSeparator = System.getProperty("line.separator");

	// tB^
	private Vector filters;

	// \Ԋu
	private int interval;

	// \s
	private int lines;

	public JTailData()
	{
		data = new StringBuffer();
		filters = new Vector();
	}

	/**
	 *	eLXgf[^̒ǉ
	 */
	public void appendText(String str)
	{
		data.append(str);
	}

	/**
	 *	tB^̒ǉ
	 */
	public void addFilter(TextFilter filter)
	{
		filters.add(filter);
	}

	/**
	 *	HeLXg̎擾
	 */
	public String getEditedString() throws IOException
	{
		// StringBuffer  Stringϊ
		String str = data.toString();

		// ǂݍݏ
		BufferedReader reader = new BufferedReader(new StringReader(str));

		// ʊi[pIuWFNg
		Vector result = new Vector();

		// ǂݍ
		String buf;
		while((buf = reader.readLine()) != null)
		{
			// tB^O
			EditedString editstr = new EditedString(buf);
			for(int i=0; i<filters.size() && buf != null; i++)
			{
				TextFilter filter = (TextFilter)filters.get(i);
				editstr = filter.edit(editstr);
			}

			// tB^̌ʂnullłȂΌʂɒǉ
			if(editstr.getString() != null)
			{
				result.add(editstr.getHTMLEditedString());
			}
		}

		// ǂݍ݌n
		reader.close();

		StringBuffer resultStr = new StringBuffer();
		int endIndex = (result.size() >= lines) ? (result.size() - lines) : 0;

		for(int i=endIndex; i<result.size(); i++)
		{
			resultStr.append((String)result.get(i));
		}

		// ʂTABLE^Ot^
		resultStr.insert(0, "<table width = \"100%\" cellspacing = \"0\" cellpadding = \"0\">");
		resultStr.append("</table>");

		return resultStr.toString();
	}

	/**
	 *	f[^̃NA
	 */
	public void clear()
	{
		data = new StringBuffer();
	}

	/**
	 *	\Ԋu̎擾
	 */
	public int getInterval()
	{
		return interval;
	}

	/**
	 *	\Ԋu̐ݒ
	 */
	public void setInterval(int interval)
	{
		this.interval = interval;
	}

	/**
	 *	\s̎擾
	 */
	public int getLines()
	{
		return lines;
	}

	/**
	 *	\s̐ݒ
	 */
	public void setLines(int lines)
	{
		this.lines = lines;
	}

	/**
	 *	Object#toString̃I[oCh
	 */
	public String toString()
	{
		StringBuffer result = new StringBuffer();
		result.append("Interval = " + interval + lineSeparator);
		result.append("Lines = " + lines + lineSeparator);
		result.append("NumFilter = " + filters.size() + lineSeparator);

		return result.toString();
	}
}
