package jtail;

import java.awt.event.*;
import java.io.*;
import java.util.Observable;

import javax.swing.*;
import javax.swing.event.*;

/**
 *	IɃt@Cǂݍ݂sNX
 */
public class ReadFileTask extends Observable implements ActionListener
{
	private static final String lineSeparator = System.getProperty("line.separator");
	private String fileName = "test.txt";
	private long prevSize;

	/**
	 *	ftHgRXgN^
	 */
	public ReadFileTask()
	{
		prevSize = 0;
	}

	/**
	 *	t@Cw肵č\z
	 */
	public ReadFileTask(String fileName)
	{
		this.fileName = fileName;
		prevSize = 0;
	}

	/**
	 *	^C}
	 */
	public void actionPerformed(ActionEvent ae)
	{
		try
		{
			File file = new File(fileName);

			if(file.length() != prevSize)
			{
				// Observerւ̒ʒmJn
				setChanged();

				BufferedReader reader = new BufferedReader(new FileReader(file));
				reader.skip(prevSize);

				// ύXӏ
				StringBuffer diffText = new StringBuffer();

				String buf;
				while((buf = reader.readLine()) != null)
				{
					diffText.append(buf + lineSeparator);
				}

				reader.close();

				// Observerɒʒm
				notifyObservers(diffText.toString());

				// Observerւ̒ʒmI
				clearChanged();
			}

			this.prevSize = file.length();
		}
		catch(IOException io_ex)
		{
			io_ex.printStackTrace();
		}
	}
}
